<template>
  <div class="page-restaurant" :class="themeClasses">
    <restaurant-header
      :groupId="groupId"
      :loading="loading"
      @goToSection="goToSection"
      :restaurant="restaurant"
      :sections="sections"
    >
      <template slot="preorderMenu"><preorder-menu /></template>
    </restaurant-header>
    <div class="container m-container-no-gutter">
      <div class="row justify-content-end">
        <div class="col-12 col-md-9">
          <ul class="reset-list" :class="themeClasses">
            <li ref="waitingAndBooking">
              <announcement
                v-if="restaurant && restaurant.bookingAnnouncement"
                :text="restaurant.bookingAnnouncement"
              />
              <div>
                <div class="tab-container">
                  <!-- 餐聽Tab -->
                  <div
                    v-if="isDelivery || isPreorder"
                    class="preorder-tutorial-entrance"
                    @click.stop.prevent="openPreorderTutorialPage()"
                  >
                    <div class="icon"></div>
                  </div>
                  <div
                    class="row tabs"
                    :class="isDelivery || isPreorder ? 'mb-2' : ''"
                  >
                    <div
                      v-for="(tab, key) in tabs"
                      class="col col-3 col-md-auto"
                      :key="key"
                    >
                      <component
                        class="d-block tab"
                        :class="[
                          `tab--${key}`,
                          { 'tab--disabled': !tabAvailable(key) },
                          {
                            'router-link-active':
                              tabRouteName(key) == $route.name
                          }
                        ]"
                        :is="tabAvailable(key) ? 'a' : 'div'"
                        @click="tabRoute(key)"
                        href="javascript:;"
                      >
                        <span class="tab__cube">
                          <i class="tab__check">&#10003;</i>
                          <span>{{ tab }}</span>
                        </span>
                      </component>
                    </div>
                  </div>

                  <!-- 外帶提醒 -->
                  <div class="order-title" v-show="isPreorder">
                    <h4>{{ $t(`restaurant.orderTitle`) }}</h4>
                    <div class="alarm">
                      <alarm class="py-0">
                        <span slot="tag">{{
                          $t("preorderGroup.warningTag")
                        }}</span>
                        <div
                          slot="content"
                          v-html="$t(`restaurant.preorderDesc`)"
                        ></div>
                      </alarm>
                    </div>
                  </div>
                  <!-- 外送提醒 -->
                  <!-- <div class="order-title" v-show="isDelivery">
                    <h4>{{ $t(`restaurant.orderTitle`) }}</h4>
                    <div class="alarm">
                      <alarm class="py-0">
                        <span slot="tag">{{
                          $t("preorderGroup.warningTag")
                        }}</span>
                        <div
                          slot="content"
                          v-html="$t(`restaurant.deliveryDesc`)"
                        ></div>
                      </alarm>
                    </div>
                  </div> -->

                  <div
                    class="restaurant-detail-content tab-body"
                    :class="themeClasses"
                  >
                    <template v-if="!loading">
                      <router-view ref="view"></router-view>
                    </template>
                    <template v-else>
                      <div class="loading py-5">
                        <div
                          class="lp mt-4 mx-auto"
                          style="width: 172px; line-height: 30px"
                        ></div>
                        <div
                          class="lp mt-3 mx-auto"
                          style="width: 218px;line-height: 16px"
                        ></div>
                        <div
                          class="lp mt-2 mx-auto"
                          style="width: 218px;line-height: 16px"
                        ></div>
                      </div>
                    </template>
                  </div>
                </div>
              </div>
            </li>

            <template v-if="!loading && showInfo">
              <li ref="info">
                <div
                  class="restaurant-detail-section-title content-large"
                  :class="themeClasses"
                >
                  {{ $t("restaurant.info") }}
                </div>
                <div class="restaurant-detail-content" :class="themeClasses">
                  <real-map-info
                    v-if="realmap[groupId]"
                    :image="realmap[groupId].image"
                    :restaurants="[restaurant]"
                  />
                  <restaurant-info
                    v-else
                    :restaurant="restaurant"
                    :group-id="groupId"
                  />
                </div>
              </li>
              <li v-if="restaurant.menus.length" ref="menu">
                <div
                  class="restaurant-detail-section-title content-large"
                  :class="themeClasses"
                >
                  {{ $t("restaurant.menu") }}
                </div>
                <div class="restaurant-detail-content" :class="themeClasses">
                  <restaurant-menu :restaurant="restaurant" />
                </div>
              </li>
              <li
                ref="recommendedRestaurants"
                v-show="restaurant.recommendedBranches.length"
              >
                <div
                  class="restaurant-detail-section-title content-large"
                  :class="themeClasses"
                >
                  {{ $t("restaurant.recommendedRestaurants") }}
                </div>
                <div class="restaurant-detail-content" :class="themeClasses">
                  <restaurant-item
                    v-for="r in restaurant.recommendedBranches"
                    listType="related recommendation"
                    :key="r.id"
                    :restaurant="r"
                    strategy="waiting"
                  />
                </div>
              </li>
            </template>
          </ul>
        </div>
      </div>
    </div>
    <warning-popup
      v-show="showWarning"
      @close-click="closeWarning"
      @leave="leave"
    />
  </div>
</template>
<script>
import realmap from "@/const/realmap";
import { mapState, mapMutations, mapGetters, mapActions } from "vuex";
import _ from "underscore";
import RestaurantHeader from "@/components/Restaurant/Header";
import RestaurantInfo from "@/components/Restaurant/Info";
import RealMapInfo from "@/components/Restaurant/RealMapInfo";
import RestaurantItem from "@/components/Group/RestaurantItem";
import TabBooking from "@/components/Restaurant/TabBooking";
import TabWaiting from "@/components/Restaurant/TabWaiting";
import RestaurantMenu from "@/components/Restaurant/Menu";
import Announcement from "@/components/Restaurant/Announcement";
import PreorderMenu from "@/components/Restaurant/Preorder/Menu";
import WarningPopup from "@/components/Restaurant/WarningPopup";
import Remind from "@/components/Remind";
import Alarm from "@/components/Alarm";
import {
  inViewport,
  preorderAvailable,
  restaurantServiceStrategy
} from "@/utils";
import capitalize from "lodash/capitalize";

export default {
  beforeRouteLeave(to, from, next) {
    if (
      this.$refs.view.cart &&
      this.$refs.view.cart.length &&
      to.name !== "SkmpayInfo"
    ) {
      this.showWarning = true;
    } else {
      next();
    }
  },
  props: {
    groupId: {
      type: String,
      required: true
    },
    companyId: {
      type: String,
      required: true
    },
    id: {
      type: String,
      required: true
    },
    date: {
      type: String
    },
    groupSize: {
      type: Number
    }
  },
  data() {
    return {
      loading: true,
      currentSection: "waitingAndBooking",
      showWarning: false
    };
  },
  components: {
    Alarm,
    Remind,
    RestaurantHeader,
    RestaurantInfo,
    RestaurantMenu,
    TabBooking,
    TabWaiting,
    RestaurantItem,
    PreorderMenu,
    Announcement,
    RealMapInfo,
    WarningPopup
  },
  computed: {
    ...mapState(["locale"]),
    ...mapState("restaurant", ["restaurant"]),
    ...mapGetters("theme", ["themeClasses"]),
    ...mapState("branch", {
      selection: "select",
      showBranchSelectorPopup: "showBranchSelectorPopup",
      isMatchDeliveryScope: "isMatchDeliveryScope"
    }),
    preorderAvailable() {
      return preorderAvailable(this.groupId);
    },
    realmap() {
      return realmap;
    },
    tabs() {
      return this.$t("restaurant.tab");
    },
    sections() {
      const restaurant = this.restaurant;
      const sections = ["waitingAndBooking", "info"];

      if (!restaurant) {
        return [];
      }

      if (restaurant.menus.length) {
        sections.push("menu");
      }
      if (restaurant.recommendedBranches.length) {
        sections.push("recommendedRestaurants");
      }
      return sections.map(s => ({ name: s, active: s == this.currentSection }));
    },
    query() {
      return this.$route.query;
    },
    params() {
      return this.$route.params;
    },
    showInfo() {
      return !this.isDelivery && !this.isPreorder;
    },
    isDelivery() {
      return this.$route.name === "RestaurantDelivery";
    },
    isPreorder() {
      return this.$route.name === "RestaurantPreorder";
    },
    tabType() {
      return {
        RestaurantWaiting: "waiting",
        RestaurantBooking: "booking",
        RestaurantPreorder: "preorder",
        RestaurantDelivery: "delivery"
      }[this.$route.name];
    }
  },
  methods: {
    ...mapMutations("restaurant", ["setRestaurant"]),
    ...mapActions("branch", [
      "checkDelivery",
      "openBranchSelectorPopup",
      "closeBranchSelectorPopup",
      "resetSelectorCurrent"
    ]),
    fetchRestaurant() {
      this.loading = true;
      const { groupId, companyId, id, date, groupSize } = this;
      const params = { date, size: groupSize, language: this.locale };
      return this.$store
        .dispatch("restaurant/fetchRestaurant", {
          groupId,
          companyId,
          id,
          params
        })
        .then(() => {
          this.loading = false;
        });
    },
    tabRouteName(key) {
      return `Restaurant${capitalize(key)}`;
    },
    tabRoute(key) {
      if (
        this.tabAvailable(key) &&
        this.tabRouteName(key) != this.$route.name
      ) {
        if (this.tabRouteName(key) === "RestaurantDelivery") {
          if (this.isMatchDeliveryScope && this.query.time && this.query.date) {
            this.$router.push({
              name: this.tabRouteName(key),
              params: this.params,
              query: this.query
            });
          } else {
            this.openBranchSelectorPopup({
              isDeliveryPopup: true,
              companyId: this.params.companyId,
              id: this.params.id
            });
          }
        } else {
          this.$router.push({
            name: this.tabRouteName(key),
            params: this.params,
            query: this.query
          });
        }
      } else {
        return false;
      }
    },
    goToSection(section) {
      this.currentSection = section;
      this.sectionListener(false);
      this.$scrollTo(this.$refs[section], 500, {
        onDone: () => {
          this.sectionListener(true);
        }
      });
    },
    openPreorderTutorialPage() {
      this.$router.push(`/preorder-tutorial`);
    },
    detectSection: _.throttle(function() {
      let el, found;

      this.sections.forEach(section => {
        el = this.$refs[section.name];

        if (el && inViewport(el, { threshold: 0.5 })) {
          this.currentSection = section.name;
        }
      });
    }, 100),
    sectionListener(bool) {
      if (bool) {
        window.addEventListener("scroll", this.detectSection);
      } else {
        window.removeEventListener("scroll", this.detectSection);
      }
    },
    track() {
      const { name } = this.restaurant.company;
      const { time, listType } = this.$route.query;
      const by = listType ? listType : time ? "booking list" : "waiting list";
      const properties = { ...this.restaurant.dataForMixpanel, with: time, by };
      window.gtag("event", `Restaurant - Enter`, {
        event_label: JSON.stringify({
          properties
        })
      });
    },
    tabAvailable(key) {
      return restaurantServiceStrategy(key, this.restaurant);
    },
    closeWarning() {
      this.showWarning = false;
    },
    leave() {
      this.showWarning = false;
      this.$refs.view.cart = [];
      this.$refs.view.removeCartCookie();
      this.$router.push({ name: this.$router.history.pending.name });
    },
    capitalize
  },
  destroyed() {
    this.setRestaurant(undefined);
    this.sectionListener(false);
  },
  created() {
    this.fetchRestaurant().then(this.track);
  },
  mounted() {
    this.sectionListener(true);
    if (this.isDelivery) {
      if (!this.isMatchDeliveryScope || !this.query.time || !this.query.date) {
        this.$router.push({
          name: this.tabRouteName("booking"),
          params: this.params,
          query: this.query
        });
      }
    }
  },
  watch: {
    id() {
      this.setRestaurant(undefined);
      this.fetchRestaurant();
    }
    // $route(to, from) {
    //   if (to.name === "RestaurantDelivery") {
    //     //
    //   }
    // }
  }
};
</script>

<style lang="scss">
.page-restaurant {
  @include media-breakpoint-down(sm) {
    background-color: $color-white;
  }

  &.theme-vip-member {
    background: $color-gold-100;
    margin-bottom: 30px;
  }
}

.tab-body {
  padding-bottom: 10px;
  overflow: hidden;
}

.tab-container {
  // @include media-breakpoint-up(md) {
  //   padding: 20px 0 0 0;
  // }
  padding-top: 25px;
  @include media-breakpoint-up(md) {
    padding-top: 44px;
    margin-top: 65px;
    background-color: $white;
  }

  .preorder-tutorial-entrance {
    width: 100%;
    // height: 26px;
    position: relative;
    .icon {
      position: absolute;
      z-index: 2;
      // transform: translateY(19px);
      width: 26px;
      height: 26px;
      right: 8px;
      bottom: 0;
      background: url("/static/images/preorder-tutorial/ic-takeout-desc.svg")
        no-repeat center center;
      background-size: cover;
      cursor: pointer;
      @include media-breakpoint-up(md) {
        width: 32px;
        height: 32px;
        right: 28px;
      }
    }
  }

  .row.tabs {
    padding: 0 16px;

    .col {
      padding: 0 4px;
    }

    @include media-breakpoint-up(md) {
      margin-left: -4px;
      margin-right: -4px;
      padding: 0 28px;
      .col {
        max-width: 108px;
        width: 108px;
      }
    }
  }

  .tab {
    .tab__cube {
      display: block;
      height: 36px;
      border-radius: 36px;
      // line-height: 36px;
      font-size: 14px;
      text-align: center;
      &:before {
        content: "";
        height: 102%;
        vertical-align: middle;
        display: inline-block;
      }
      .tab__check {
        display: none;
        width: 16px;
        height: 16px;
        background-color: $white;
        border-radius: 16px;
        font-weight: bolder;
        line-height: 16px;
      }

      @include media-breakpoint-up(md) {
        font-size: 16px;
      }
    }
    &.router-link-active {
      .tab__check {
        // display: inline-block;
        display: none;
        margin-right: 4px;
      }
      .tab__cube {
        color: $white;
      }
    }
    &--booking {
      .tab__cube {
        color: map_get($tab-colors, "booking");
        border: 1px map_get($tab-colors, "booking") solid;
      }
      &.router-link-active {
        .tab__cube {
          background-color: map_get($tab-colors, "booking");
          border-color: map_get($tab-colors, "booking");
        }
        .tab__check {
          color: map_get($tab-colors, "booking");
        }
      }
    }

    &--waiting {
      .tab__cube {
        color: map_get($tab-colors, "waiting");
        border: 1px map_get($tab-colors, "waiting") solid;
      }
      &.router-link-active {
        .tab__cube {
          background-color: map_get($tab-colors, "waiting");
          border-color: map_get($tab-colors, "waiting");
        }
        .tab__check {
          color: map_get($tab-colors, "waiting");
        }
      }
    }

    &--preorder {
      .tab__cube {
        color: map_get($tab-colors, "preorder");
        border: 1px map_get($tab-colors, "preorder") solid;
      }
      &.router-link-active {
        .tab__cube {
          background-color: map_get($tab-colors, "preorder");
          border-color: map_get($tab-colors, "preorder");
        }
        .tab__check {
          color: map_get($tab-colors, "preorder");
        }
      }
    }

    &--delivery {
      .tab__cube {
        color: map_get($tab-colors, "delivery");
        border: 1px map_get($tab-colors, "delivery") solid;
      }
      &.router-link-active {
        .tab__cube {
          background-color: map_get($tab-colors, "delivery");
          border-color: map_get($tab-colors, "delivery");
        }
        .tab__check {
          color: map_get($tab-colors, "delivery");
        }
      }
    }

    &--disabled {
      .tab__cube {
        cursor: not-allowed;
        background-color: $color-genesis-white !important;
        border-color: $color-genesis-white;
        color: $color-silver-grey;
        .tab__check {
          color: $color-genesis-white !important;
        }
      }
    }
  }
}

.order {
  &-title {
    padding: 10px 8px 0;
    h4 {
      font-size: 24px;
    }

    @include media-breakpoint-up(md) {
      padding: 20px 28px;
    }
  }
  &-desc {
    font-size: 16px;
    line-height: 26px;
  }
}

// .tab-menu {
//   position: relative;
//   z-index: 1;
//   box-shadow: 0 2px 4px 0 rgba(0, 0, 0, 0.06);

//   @include media-breakpoint-up(md) {
//     font-size: 18px;
//     box-shadow: none;
//   }
// }

// .tab-menu-link {
//   line-height: 44px;
//   width: 100%;
//   color: $color-secondary-black;
//   &.router-link-active {
//     color: $color-skm-red;
//     font-weight: 500;
//   }
//   @include media-breakpoint-up(md) {
//     width: 135px;

//     &:lang(en) {
//       width: 170px;
//     }
//   }
// }

// .tab-menu-divider {
//   width: 1px;
//   height: 20px;
//   background-color: $color-sky-grey;
//   flex-shrink: 0;
//   @include media-breakpoint-up(md) {
//     height: 26px;
//   }
// }

.alarm {
  .tutorial-button-container {
    display: inline-flex;
    flex-direction: row;
    align-items: center;
    margin-top: 10px;
    .ic-proc-next {
      display: block;
      width: 16px;
      height: 16px;
      background: url("/static/images/preorder-tutorial/ic-proc-next.svg");
      margin: 0 15px;
      &:last-child {
        display: none;
      }
    }
  }
}
</style>
